# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.datasource import Datasource  # noqa: F401,E501
from swagger_server.models.datasource_type import DatasourceType  # noqa: F401,E501
from swagger_server.models.owm_metrics import OwmMetrics  # noqa: F401,E501
from swagger_server import util


class OwmDatasource(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, datasource_type: DatasourceType=None, id: str=None, city_uid: int=None, metrics: List[OwmMetrics]=None, topic_name: str=None):  # noqa: E501
        """OwmDatasource - a model defined in Swagger

        :param datasource_type: The datasource_type of this OwmDatasource.  # noqa: E501
        :type datasource_type: DatasourceType
        :param id: The id of this OwmDatasource.  # noqa: E501
        :type id: str
        :param city_uid: The city_uid of this OwmDatasource.  # noqa: E501
        :type city_uid: int
        :param metrics: The metrics of this OwmDatasource.  # noqa: E501
        :type metrics: List[OwmMetrics]
        :param topic_name: The topic_name of this OwmDatasource.  # noqa: E501
        :type topic_name: str
        """
        self.swagger_types = {
            'datasource_type': DatasourceType,
            'id': str,
            'city_uid': int,
            'metrics': List[OwmMetrics],
            'topic_name': str
        }

        self.attribute_map = {
            'datasource_type': 'datasource-type',
            'id': 'id',
            'city_uid': 'city-uid',
            'metrics': 'metrics',
            'topic_name': 'topic-name'
        }
        self._datasource_type = datasource_type
        self._id = id
        self._city_uid = city_uid
        self._metrics = metrics
        self._topic_name = topic_name

    @classmethod
    def from_dict(cls, dikt) -> 'OwmDatasource':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The owm-datasource of this OwmDatasource.  # noqa: E501
        :rtype: OwmDatasource
        """
        return util.deserialize_model(dikt, cls)

    @property
    def datasource_type(self) -> DatasourceType:
        """Gets the datasource_type of this OwmDatasource.


        :return: The datasource_type of this OwmDatasource.
        :rtype: DatasourceType
        """
        return self._datasource_type

    @datasource_type.setter
    def datasource_type(self, datasource_type: DatasourceType):
        """Sets the datasource_type of this OwmDatasource.


        :param datasource_type: The datasource_type of this OwmDatasource.
        :type datasource_type: DatasourceType
        """

        self._datasource_type = datasource_type

    @property
    def id(self) -> str:
        """Gets the id of this OwmDatasource.

        Identifier of the OWM datasource  # noqa: E501

        :return: The id of this OwmDatasource.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str):
        """Sets the id of this OwmDatasource.

        Identifier of the OWM datasource  # noqa: E501

        :param id: The id of this OwmDatasource.
        :type id: str
        """

        self._id = id

    @property
    def city_uid(self) -> int:
        """Gets the city_uid of this OwmDatasource.

        Identifier of the city whose current and forecast weather data must be retrieved.  # noqa: E501

        :return: The city_uid of this OwmDatasource.
        :rtype: int
        """
        return self._city_uid

    @city_uid.setter
    def city_uid(self, city_uid: int):
        """Sets the city_uid of this OwmDatasource.

        Identifier of the city whose current and forecast weather data must be retrieved.  # noqa: E501

        :param city_uid: The city_uid of this OwmDatasource.
        :type city_uid: int
        """
        if city_uid is None:
            raise ValueError("Invalid value for `city_uid`, must not be `None`")  # noqa: E501

        self._city_uid = city_uid

    @property
    def metrics(self) -> List[OwmMetrics]:
        """Gets the metrics of this OwmDatasource.

        List of the weather metrics to be retrieved by this datasource. If not specified, it will retrieve all the metrics.  # noqa: E501

        :return: The metrics of this OwmDatasource.
        :rtype: List[OwmMetrics]
        """
        return self._metrics

    @metrics.setter
    def metrics(self, metrics: List[OwmMetrics]):
        """Sets the metrics of this OwmDatasource.

        List of the weather metrics to be retrieved by this datasource. If not specified, it will retrieve all the metrics.  # noqa: E501

        :param metrics: The metrics of this OwmDatasource.
        :type metrics: List[OwmMetrics]
        """

        self._metrics = metrics

    @property
    def topic_name(self) -> str:
        """Gets the topic_name of this OwmDatasource.

        Kafka topic in which metrics of this datasource will be published. If empty the metrics will be published in a Kafka topic named according a predefined pattern.  # noqa: E501

        :return: The topic_name of this OwmDatasource.
        :rtype: str
        """
        return self._topic_name

    @topic_name.setter
    def topic_name(self, topic_name: str):
        """Sets the topic_name of this OwmDatasource.

        Kafka topic in which metrics of this datasource will be published. If empty the metrics will be published in a Kafka topic named according a predefined pattern.  # noqa: E501

        :param topic_name: The topic_name of this OwmDatasource.
        :type topic_name: str
        """

        self._topic_name = topic_name
